-- This is an example of how to do a procedural script in PostgreSQL
-- This one gets duplicate location names from the location table and
-- deletes them after moving events to the first dupe name.
DO
$do$
DECLARE
    r RECORD;
BEGIN

   FOR r IN SELECT LOWER(location_name) AS locname,
       	    MIN(location_id) AS minid,
            COUNT(*) AS cnt
         FROM location
         GROUP BY 1
         HAVING COUNT(*) > 1 LOOP

      RAISE NOTICE 'Location name: %, ID: %, count: %',r.locname,r.minid,r.cnt;

      UPDATE calitem SET location_id=r.minid
      WHERE location_id IN (
         SELECT location_id 
           FROM location 
           WHERE location_name ILIKE r.locname AND location_id<>r.minid
         );

      DELETE FROM location WHERE location_name ILIKE r.locname AND location_id<>r.minid;

   END LOOP;

END;
$do$;
