/*
    connectDaily Web Calendar Software

    Copyright 2017, MH Software, Inc. All Rights Reserved
    5023 W 120th Ave #311, Broomfield CO 80020
    +1 303 438 9585

    Last Edit By: "$Author: gsexton $"
    Last Checkin: "$Date: 2018/03/02 18:54:30 $"
    Revision #  : "$Revision: 1.1 $"
*/
/** 
  * This file handles interfacing connectDaily with intro.js 
  *  
  * It's in AMD format for dynamic loading via Dojo/require 
  *  
  * @author gsexton 
  *  
  * @since 5.0.0 (7/27/17) 
 */
define(function() {
        var tourID = null,
            completed = false,
            obj = {
            "setTourID": function(newID) {
                tourID = newID;
                },
            "onafterchange": function(targetElement) {
                /*
                    Given callback function will be called after starting a new step of
                    introduction. The callback function receives the element of the new
                    step as an argument.
                */
                },
            "onbeforechange": function(targetElement) {
                /*
                    Given callback function will be called before starting a new step of 
                    introduction. The callback function receives the element of the new 
                    step as an argument.
                */
                require(['dojo/dom-attr','dojo/dom-class'],function(domAttr,domClass){
                     if (domClass.contains(targetElement,"dijitPopupMenuItem")) {
                         var mp=dijit.byId('IDcdEditMenuPad');
                         mp.popup.emit('click');
                     } else if (domClass.contains(targetElement,'dijitMenuItem')) {
                         if (domAttr.has(targetElement,'data-parent-menu-pad')) {
                             var mp=dijit.byId(domAttr.get(targetElement,'data-parent-menu-pad'));
                             mp.emit('click');
                         }
                         targetElement.focus();
                     }
                 });
            },
            "onchange": function(targetElement) {
                /*
                    Set callback to change of each step of introduction. Given callback 
                    function will be called after completing each step. The callback 
                    function receives the element of the new step as an argument.    
                */
                },
            "onexit": function() {
                /*
                    Set callback to exit of introduction. Exit also means pressing
                    ESC key and clicking on the overlay layer by the user.
                */
                if (!completed) {
                    obj.markStatus(false);
                }
                },
            "oncomplete": function() {
                /*
                    Set callback for when introduction completed.
                */
                completed = true;
                obj.markStatus(true);
                },
            "markStatus": function(complete) {
                require( [ "dojo/request/xhr" ], function(xhr) {
                        xhr("json/markTourStatus.js",
                            {
                                "method": "GET",
                                "sync": true,
                                "preventCache": true,
                                "query": {
                                    "request_number": "MARK_TOUR_" + (complete ? "COMPLETED" : "SEEN"),
                                    "TourID": tourID
                                },
                                "handleAs": "json"
                            }).then(function(data) {
                                // Return has: result, message, validationCode
                                if (data.result === 0) {
                                    // Nothing
                                } else {
                                    alert(data.message);
                                }
                            });
                    });

                }
        };
        return obj;
    });
